<?php

namespace App\Validator;

use App\Service\ImageSafetyServiceInterface;
use Symfony\Component\Validator\Constraint;
use Symfony\Component\Validator\ConstraintValidator;

class ImageSafetyValidator extends ConstraintValidator
{
    public function __construct(private readonly ImageSafetyServiceInterface $imageSafetyService)
    {
    }

    public function validate($value, Constraint $constraint): void
    {
        /* @var ImageSafety $constraint */

        if (null === $value || '' === $value) {
            return;
        }

        if (!$this->imageSafetyService->isValid($value)) {
            $this->context->buildViolation($constraint->message)->addViolation();
        }
    }
}
